(function (exports) {
    var dataLoading = false;
    var txtEmployeeSearch, dailyStatusWrapper, employeeSearchWrapper;
    var employees;
    var canEdit = false;

    function setupTemplates(filter) {
        var listItemTemplate =
            '<li class="list-group-item" style="/*display: none;*/">' +
            '<div class="container">' +
            '<h3>' +
            (!canEdit ?
                '<span class="name">#data.Name#</span>' :
                '<a href="#" data-personid="#data.PersonID#" title="Click to edit"><span class="name">#data.Name#</span></a>') +
            '</h3>' +
            '<table>' +
            '<tr>' +
            '<td>' +
            '<span class="imagespan pull-left">' +
            '<img id="#ImgId#" class="image fancyPhoto" src="https://www.pioneerrx.com/api/Preferences/Person/#data.PersonID#/Image" />' +
            '</span>' +
            '</td>' +
            '<td class="pad-left vertical-top">' +
            '<span>' +
            '<p style="#WorkAreaStyle#">' +
            '<span style="font-weight: bold; color: #293955;">Work Area: </span>' + '#data.WorkArea#' +
            '</p>' +
            '<p style="#SupportTypeStyle#">' +
            '<span style="font-weight: bold; color: #293955;">Support Type: </span>' + '#data.SupportType#' +
            '</p>' +
            '<p style="#PhoneExtStyle#">' +
            '<span style="font-weight: bold; color: #293955;">Ext: </span>' + '#data.PhoneExt#' +
            '</p>' +
            '<p>' +
            '<span style="font-weight: bold; color: #293955;">Email: </span>' + '<a href="mailto:#data.Email#" title="Click to send email">#data.Email#</a>' +
            '</p>' +
            '<p style="#WithPioneerStyle#">' +
            '<span style="font-weight: bold; color: #293955;">With Pioneer: </span>' + '#data.TimeEmployeed#' +
            '</p>' +
            '<p style="#AvailabilityVisibilityStyle#">' +
            '<span style="font-weight: bold; color: #293955;">Status: </span>' + '<span class="" style="color: #AvailabilityColor#; #AvailabilityTextStyle#"><b>#AvailabilityText#</b></span>' +
            '</p>' +
            '</span>' +
            '</td>' +
            '</tr>' +
            '</table>' +
            '</div>' +
            '</li>';

        var employeeList = $('#employeeList');
        employeeList.empty();
        var filteredItemCount = 0;
        $(employees).each(function (index, employee) {
            var filters = filter.split(' ');
            var longestFilter = '';
            $(filters).each(function (index, filterItem) {
                if (filterItem.length > longestFilter.length) {
                    longestFilter = filterItem;
                }
            });

            if (employee.name.toUpperCase().indexOf(longestFilter) > -1) {
                ++filteredItemCount;
                var template = listItemTemplate;
                template = template.replace(new RegExp('#ImgId#', 'g'), ('employeeImageId_' + index));
                template = template.replace(new RegExp('#data.ImageName#', 'g'), employee.imageName);
                template = template.replace(new RegExp('#data.Name#', 'g'), employee.name);
                template = template.replace(new RegExp('#data.PersonID#', 'g'), employee.personID);
                template = template.replace(new RegExp('#data.WorkArea#', 'g'), employee.workArea);
                template = template.replace(new RegExp('#data.SupportType#', 'g'), employee.supportType);
                template = template.replace(new RegExp('#data.PhoneExt#', 'g'), employee.phoneExt);
                template = template.replace(new RegExp('#data.Email#', 'g'), employee.emailAddress);

                var employmentTimeString = employee.employmentString;
                template = template.replace(new RegExp('#data.TimeEmployeed#', 'g'), employmentTimeString);

                var workAreaStyle = (employee.personID == "00000000-0000-0000-0000-000000000000" ? "display: none;" : "");
                var supportTypeStyle = (!employee.supportType ? "display: none;" : "");
                var phoneExtStyle = (employee.personID == "00000000-0000-0000-0000-000000000000" ? "margin-top: 15px;" : "");
                var availabilityVisibilityStyle = (employee.personID == "00000000-0000-0000-0000-000000000000" ? "display: none;" : "");
                var availabilityColor = (employee.availabilityColor ?
                    (employee.availabilityTypeText == "Busy" ? "darkgoldenrod" : employee.availabilityColor) :
                    (employee.isClockedIn == 1 ? "green" : "red"));
                var availabilityTextStyle = (employee.availabilityTypeText == null && employee.isClockedIn == null ? "display: none;" : "");
                var availabilityText = (employee.availabilityTypeText == "Out Of Office" ? "Out" :
                    (employee.availabilityTypeText ? employee.availabilityTypeText : "(Unknown)"));
                var withPioneerStyle = (!employee.employmentString ? "display: none;" : "");

                template = template.replace('#WorkAreaStyle#', workAreaStyle);
                template = template.replace('#SupportTypeStyle#', supportTypeStyle);
                template = template.replace('#PhoneExtStyle#', phoneExtStyle);
                template = template.replace('#AvailabilityVisibilityStyle#', availabilityVisibilityStyle);
                template = template.replace('#AvailabilityColor#', availabilityColor);
                template = template.replace('#AvailabilityTextStyle#', availabilityTextStyle);
                template = template.replace('#AvailabilityText#', availabilityText);
                template = template.replace('#WithPioneerStyle#', withPioneerStyle);


                employeeList.append(template);
                $('#' + ('employeeImageId_' + index)).load(function () {
                    $(this).fadeIn(750);
                });

                $('#' + ('employeeImageId_' + index)).error(function () {
                    this.onError = null; this.src = 'assets/img/PioneerRx-Icon.png'; this.className = 'error';
                });
            }
        });

        if (filteredItemCount > 1) {
            employeeList.removeClass('no-scrollbar');
        }
        else {
            employeeList.addClass('no-scrollbar');
        }
    }

    function loadEmployees() {
        var searchText = (txtEmployeeSearch.value || '').trim();
        if (!dataLoading && searchText.length >= 3) {
            dataLoading = true;

            var productionUrl = 'https://www.pioneerrx.com/api/Availability/EmployeeList';
            var debugUrl = 'https://prxafausett.pioneerrx.com/pioneerrxinternet/api/Availability/EmployeeList';

            var data = {
                //token: currentSettings.securityToken,
                searchText: searchText
            };
            $.ajax({
                type: 'POST',
                url: (useProduction ? productionUrl : debugUrl),
                //contentType: 'application/json; charset=utf-8',
                //dataType: 'json',
                data: '=' + searchText,
                beforeSend: function () {
                }
            })
                .done(function (data) {
                    employees = data.employees;
                    canEdit = data.canEdit;
                })
                .fail(function (err) {
                    console.log(err);
                    var lblError = document.getElementById('lblEmployeeSearchError');

                    $(lblError).removeClass('hide');
                    lblError.innerHTML = 'Error loading employees&hellip;';

                    var employeeSearchWrapper = document.getElementById('employeeListWrapper');
                    setTimeout(function () {
                        txtEmployeeSearch.value = '';
                        $('#employeeList').hide();
                        $('#searchclear').hide();
                        txtEmployeeSearch.focus();

                        $(dailyStatusWrapper).show();
                        setTimeout(function () {
                            $(lblError).addClass('hide');
                        }, 1500);
                    }, 750);
                })
                .always(function () {
                    filterSearchResults();

                    dataLoading = false;
                });
        }
    }

    function sortEmployeeList(filter) {
        // sort items with closest match first, then by alphabetical order
        var employeeList = $('#employeeList');
        var employeeListItems = document.getElementById('employeeList').getElementsByTagName('li');

        var items = $(employeeListItems);
        items.sort(function (a, b) {
            var A = $(a).text();
            var B = $(b).text();
            var keyA = A.toUpperCase().indexOf(filter);
            var keyB = B.toUpperCase().indexOf(filter);

            if (keyA < keyB) return -1;
            if (keyA > keyB) return 1;

            if (A < B) return -1;
            if (A > B) return 1;

            return 0;
        });

        $.each(items, function (i, li) {
            employeeList.append(li);
        });
    }

    function filterSearchResults() {
        var filter = txtEmployeeSearch.value.trim().toUpperCase();
        var searchClearBtn = $('#searchclear');
        var employeeList = $('#employeeList');

        if (filter.length > 0) {
            var filteredItemCount = 0;

            searchClearBtn.show();
            employeeList.removeClass('hide');

            setupTemplates(filter);

            sortEmployeeList(filter);

            employeeList.fadeIn(250);

            //$('html, body').scrollTop($(txtEmployeeSearch).offset().top);

            $(dailyStatusWrapper).hide();
            $('html, body').scrollTop(0);

            $('[data-personid]').on('click', function (e) {
                employeeEdit($(this).data('personid'));
            });
        }
        else {
            //employeeList.hide();
            employeeList.addClass('hide');
            searchClearBtn.hide();
            $(dailyStatusWrapper).show();
            $('html, body').scrollTop(0);
        }
    }

    var fireSearch = null;
    function txtEmployeeSearch_Keyup() {
        if (fireSearch) {
            clearTimeout(fireSearch);
        }

        fireSearch = setTimeout(function () {
            if (txtEmployeeSearch.value.trim() == '') {
                txtEmployeeSearch.value = '';
                $('#employeeList').hide();
                $('#searchclear').hide();
                txtEmployeeSearch.focus();
                $(dailyStatusWrapper).show();
                $('html, body').scrollTop(0);
            }
            else {
                loadEmployees();
            }
        }, 250);
    }

    function employeeEdit(personID) {
        var url = 'PersonEdit.aspx?PersonID=' + personID;
        chrome.runtime.sendMessage({ eventName: Events.Actions.NavigateTab, url: '/' + url, existingTabPattern: url }, null);
    }

    document.addEventListener('DOMContentLoaded', function () {
        txtEmployeeSearch = document.getElementById('txtEmployeeSearch');

        //txtEmployeeSearch.addEventListener('keyup', loadEmployees, false);
        txtEmployeeSearch.addEventListener('keyup', txtEmployeeSearch_Keyup, false);

        dailyStatusWrapper = document.getElementById('divDailyStatusWrapper');
        employeeSearchWrapper = document.getElementById('employeeListWrapper');

        // set out of office image
        $('#imgOutOfOffice').attr('src', 'assets/img/outofoffice.jpg');

        $('#searchclear').hide();
        $('#employeeList').hide();

        var spanSearchClear = document.getElementById('searchclear');
        spanSearchClear.addEventListener('click', function (e) {
            txtEmployeeSearch.value = '';
            $('#employeeList').hide();
            $('#searchclear').hide();
            txtEmployeeSearch.focus();
            $(dailyStatusWrapper).show();
            $('html, body').scrollTop(0);
        }, false);
    });
})(window);

function EmployeePhoto_OnError() {
	var employeePhoto = $('#imgEmployeePhoto');

	employeePhoto[0].onerror = null;
	employeePhoto[0].onload = null;

	employeePhoto.attr('src', 'assets/img/PioneerRx-Icon.png');
	employeePhoto.removeClass('fancyPhoto');
}

function EmployeePhoto_OnLoad() {
	var employeePhoto = document.getElementById('imgEmployeePhoto');
	if (typeof employeePhoto.naturalWidth !== 'undefined' && employeePhoto.naturalWidth !== 0) {
		employeePhoto.className = 'fancyPhoto';
	}
}
