var Settings = (function () {
    var defaultOptions = {
        'enabled': true,
        'securityToken': null,
        'securityTokenTimestamp': null,
        'showDailyStatusQuickAdd': true,
        'showEmployeeSearch': true,
        'signalrEnabled': true,
        'notificationsEnabled': false,
        'notificationSound': 'teleporter',
        'newIssueNotificationsEnabled': false,
        'supportRequestNotificationsEnabled': false,
        'supportRequestNotificationSound': 'record-scratch',
        'standUpNotificationsEnabled': false,
        'standUpNotificationInterval': 45
    };
    Object.freeze(defaultOptions);

    function getSettings(responseCallback) {
        chrome.storage.sync.get(['settings'], function (data) {
            console.logv('pulled from sync');
            console.logv(data);
            var settings = $.extend({}, defaultOptions, data.settings);
            console.logv('default options');
            console.logv(defaultOptions);
            console.logv('pulled from sync and extended');
            console.logv(settings);
            responseCallback(settings);
        });
    }

    function saveSettings(settings, responseCallback) {
        console.logv('push to sync');
        console.logv(settings);

        chrome.storage.sync.set({ 'settings': settings }, function () {
            var err = chrome.runtime.lastError;
            if (err && responseCallback) {
                responseCallback({ 'success': false, 'errorMessage': err });
            }

            if (responseCallback) {
                responseCallback({ 'success': true, 'errorMessage': null });
            }
        });
    }

    return {
        get: getSettings,
        save: saveSettings
    };
})();
Object.freeze(Settings);